var PI = 3.1415926;
var briRangeDefault = 200;
var satDefault = 255;
var hueBlue = 46920;
var hueRed = 65280;

while (bundle.state == 'active')
{
	var sensorHttpRequest = new HTTPRequest('POST', 'http://192.168.1.69:8080/json-rpc/Sensor/TheSensor');
	sensorHttpRequest.contentType = 'application/json';
	sensorHttpRequest.content = JSON.stringify({"jsonrpc": "2.0", "method": "getData", "params": [], "id": 1});
	var sensorHttpResponse = sensorHttpRequest.send();
	logger.information(sensorHttpResponse.content);
	var result = JSON.parse(sensorHttpResponse.content);

	var briRange = briRangeDefault;
	var sat = satDefault;
	var hue = hueBlue;
	
	if (result.result.return.brightness < 10)
	{
		briRange = 250;
	}
	
	if (result.result.return.temperature > 24)
	{
		hue = hueRed;
	}

	for (i = 0; i < 2*PI && bundle.state == 'active'; i += PI/5)
	{
		for (l = 1; l <= 3; l++)
		{
			var httpRequest = new HTTPRequest('PUT', 'http://192.168.1.234/api/newdeveloper/lights/' + l + '/state');
			var bri = 0;
			var r = i - (l - 1)*PI/4;
			if (r > 0 && r < PI)
			{
				bri = briRange;
			}
			logger.information('' + l + ': ' + r + '/' + bri);
			httpRequest.content = JSON.stringify({on: bri > 0, bri: bri, hue: hue, sat: sat});
			//logger.information(httpRequest.content);
			httpRequest.timeout = 10.0;
			var httpResponse = httpRequest.send();
			//logger.information(httpResponse.content);
			system.sleep(100);
		}
		system.sleep(400);
	}
}
